//34567890123456789012345678901234567890123456789012345678
//Be sure to preserve < and > in html version
//Ready to publish, 02/18/08
//======================================================//

/*Exercise01.java
Copyright 2012, R.G.Baldwin

Using Java and the game-math library named GM01, or 
using a different programming environment of your 
choice, write a program that creates the wireframe 
drawing of half of a sphere protruding upward from the 
x-z plane as shown in Figure 11. The x-z plane 
intersects the sphere at the equator and only the 
northern hemisphere is visible.

*********************************************************/
import java.awt.*;
import javax.swing.*;
import java.awt.geom.*;

class Exercise01{
  public static void main(String[] args){
    GUI guiObj = new GUI();
  }//end main
}//end controlling class Exercise01
//======================================================//

class GUI extends JFrame{
  //Specify the horizontal and vertical size of a JFrame
  // object.
  int hSize = 450;
  int vSize = 450;
  Image osi;//an off-screen image
  int osiWidth;//off-screen image width
  int osiHeight;//off-screen image height
  MyCanvas myCanvas;//a subclass of Canvas

  GUI(){//constructor
    //Set JFrame size, title, and close operation.
    setSize(hSize,vSize);
    setTitle("Ex01,Baldwin");
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

    //Create a new drawing canvas and add it to the
    // center of the JFrame.
    myCanvas = new MyCanvas();
    this.getContentPane().add(myCanvas);

    //This object must be visible before you can get an
    // off-screen image.  It must also be visible before
    // you can compute the size of the canvas.
    setVisible(true);
    osiWidth = myCanvas.getWidth();
    osiHeight = myCanvas.getHeight();

    //Create an off-screen image and get a graphics
    // context on it.
    osi = createImage(osiWidth,osiHeight);
    Graphics2D g2D = (Graphics2D)(osi.getGraphics());

    //Draw the objects
    drawOffScreen(g2D);

    //Cause the overridden paint method belonging to
    // myCanvas to be executed.
    myCanvas.repaint();

  }//end constructor
  //----------------------------------------------------//

  //The purpose of this method is to create and draw a
  // wireframe drawing of  half of a sphere protruding
  // upward from the x-z plane. The x-z plane intersects
  // the sphere at the equator and only the northern
  // hemisphere is drawn.
  void drawOffScreen(Graphics2D g2D){

    //Translate the origin on the off-screen
    // image and draw orthoganal axes on it.
    setCoordinateFrame(g2D);

    //Define some working variables.
    GM01.Point3D origin = new GM01.Point3D(
                             new GM01.ColMatrix3D(0,0,0));
    GM01.Point3D point = new GM01.Point3D(
                           new GM01.ColMatrix3D(0,100,0));
    double angZ;
    double angY;
    GM01.Point3D newPoint;
    GM01.Point3D oldPoint = null;
    GM01.Line3D line;
    
    g2D.setColor(Color.BLACK);
    g2D.setStroke(new BasicStroke(3));

    //Draw the lines of latitude parallel to the equator.
    for(angZ = 0;angZ <= 90; angZ += 10){
      for(angY = 0; angY <= 360; angY += 2.5){
        newPoint = point.rotate(
                       origin,
                       new GM01.ColMatrix3D(angZ,0,angY));
        if(angY > 0){
          line = new GM01.Line3D(oldPoint,newPoint);
          line.draw(g2D);
        }//end if
        //Save the current point to use in the next
        // iteration.
        oldPoint = newPoint.clone();
      }//end inner loop
    }//end outer loop


    //Draw the lines of longitude that go through the
    // north pole.
    for(angY = 0;angY <= 360; angY += 10){
      for(angZ = 0; angZ <= 90; angZ += 2.5){
        newPoint = point.rotate(
                       origin,
                       new GM01.ColMatrix3D(angZ,0,angY));
        if(angZ > 0){
          line = new GM01.Line3D(oldPoint,newPoint);
          line.draw(g2D);
        }//end if
        //Save the current point to use in the next
        // iteration.
        oldPoint = newPoint.clone();
      }//end inner loop
    }//end outer loop

  }//end drawOffScreen
  //----------------------------------------------------//

  //The purpose of this method is to set the origin of the
  // off-screen image and to draw red, green, and blue
  // orthogonal 3D axes on the off-screen image that
  // intersect at the origin.
  private void setCoordinateFrame(Graphics2D g2D){

    //Translate the origin.
    GM01.translate(g2D,0.5*osiWidth,-0.5*osiHeight);

    g2D.setStroke(new BasicStroke(2));
    //Draw x-axis in RED
    g2D.setColor(Color.RED);
    GM01.Point3D pointA =
         new GM01.Point3D(new GM01.ColMatrix3D(-300,0,0));
    GM01.Point3D pointB =
          new GM01.Point3D(new GM01.ColMatrix3D(300,0,0));
    new GM01.Line3D(pointA,pointB).draw(g2D);

    //Draw y-axis in GREEN above the x-z plane
    g2D.setColor(Color.GREEN);
    pointA =
         new GM01.Point3D(new GM01.ColMatrix3D(0,0,0));
    pointB =
          new GM01.Point3D(new GM01.ColMatrix3D(0,300,0));
    new GM01.Line3D(pointA,pointB).draw(g2D);

    //Draw z-axis in BLUE
    g2D.setColor(Color.BLUE);
    pointA =
         new GM01.Point3D(new GM01.ColMatrix3D(0,0,-300));
    pointB =
          new GM01.Point3D(new GM01.ColMatrix3D(0,0,300));
    new GM01.Line3D(pointA,pointB).draw(g2D);

  }//end setCoordinateFrame method
  //====================================================//

  //This is an inner class of the GUI class.
  class MyCanvas extends Canvas{
    //Override the paint() method. This method will be
    // called when the JFrame and the Canvas appear on the
    // screen or when the repaint method is called on the
    // Canvas object.
    //The purpose of this method is to display the
    // off-screen image on the screen.
    public void paint(Graphics g){
      g.drawImage(osi,0,0,this);
    }//end overridden paint()

  }//end inner class MyCanvas

}//end class GUI
//======================================================//
